#ifndef MAIN_H
#define MAIN_H MAIN_H

#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <cassert>
#include <vector>
#include <sstream>
#include <string.h>
#include <direct.h> //mkdir()

#include "GCCommon.h"

#ifdef _MSC_VER
#undef min
namespace std
{
    template<class T>
    T min(T a, T b)
    {
        return a < b ? a : b;
    }

}
#endif

struct MPakHeader
{
    u16 version1; //3 or 0 part of the version
    u16 version2; //5 or 2 second part of the version (5 = mp1 2 = mp3)
    u32 size; //0 or headerSize/sectionInfoSize
    //u32 nameEntryCount;
};

struct EntryHeader
{
    u32 entryCount;
};

struct Statistics
{
    u32 numFiles;
    u32 numNames;
    u32 numCompressed;
};

extern bool bQuiet;
extern bool bVerbose;
extern Statistics mpakDump_v1(FILE* f, const std::string& name);
extern Statistics mpakDump_v3(FILE* f, const std::string& name);
//extern int makePakMP1(const char* dir, FILE* fp);
extern int returnfilesize(FILE* fp);
extern void dumpFile(const std::string& name, FILE* src, u32 offset, u32 length);

#endif // MAIN_H
